# How to Contribute

## Golden Rules
1. Be kind.
2. Imperfect feedback is [infinitely better](https://en.wikipedia.org/wiki/Perfect_is_the_enemy_of_good) than no feedback at all.

## So you've found a bug or have a suggestion and... 

### You're short on time:
No worries. This will take less than a minute. 
- Go to the github [issues page](https://github.com/jonathanchukinas/fuzzytable/issues/new/choose).
- Select the **Get Started** button next to **Bug report** or **Feature request**
- Fill in the title line.
- Delete the template out the body and briefly describe your issue/feature.
- **Submit new issue**.

### You have a bit more time:
Much appreciated!
- Go to the [github issues page](https://github.com/jonathanchukinas/fuzzytable/issues).
- Click the green **New issue** button.
- Select the **Get Started** button next to **Bug report** or **Feature request**
- Fill in the title line.
- Complete as much of the template prompt questions as you're able.
- **Submit new issue**.

### You'd like to code the solution yourself:

Awesome!!! But first...

#### Ask questions first, shoot later 

If you could, please submit an issue as detailed above.
This allows us to have a conversation about it first and figure out the best solution.
I'd hate for you to do all the work and submit a pull request only to find out it's not a direction we want the project going in.

You can also email fuzzytable.dev@gmail.com, but we'll ultimately end up creating a github issue in order to keep a paper trail. 

#### Developer Notes

1. Fork and clone the fuzzytable repo.
2. Create feature branch ``$ git checkout -b featurename``
3. Write code.
4. Write tests in ``/tests``. Install ``$ pip install tox`` and run ``$ tox`` and ensure 100% coverage.
4. Commit your changes ``git commit -am 'add some feature'``
4. Push to your remote ``git push --set-upstream origin featurename``
5. Create a new Pull Request

## Thanks!

❤❤❤

Jonathan
